<?php

/**
 This project has been generated by worker generator
 has been made by fahmi sulaiman
 sulaimanfahmi@gmail.com
 check out my github @dekaulitz
 */

namespace App\Http\Services;

use App\Http\Base\BaseService;
use App\Http\Models\LaporanbbmModel;
use App\Http\Models\LaporanbbmdetailsModel;
use App\Http\Models\SystemparameterModel;
use App\Http\Models\ItemModel;

class LaporanbbmdetailsService extends BaseService
{
	/**
     BbmService constructor.
	 */
	public function __construct()
	{
		parent::__construct();
		$this->model = new LaporanbbmdetailsModel();
		$this->penerimaanBarang = new PenerimaanbarangService();
		$this->penggunaanBarang = new PenggunaanbarangService();
		// $this->adjusmentbbmBarang = new AdjusmentbbmbarangService();
	}

	public function index()
	{
		return $this->model->getQuery()->get();
	}

	public function paging($request)
	{
		//
	}

	/**
	 *  get one raw row data from table by id
	 *  you can ad the relation like $this->model->joinSomething()->getQuery()->where("aliastable.field","=",$value)->first()
	 *  or like $this->model->joinSomething()->getQuery()->where("aliastable.field","=",$value)->select(["aliastable.fieldname"])->first(); its mean you want to join an take spesific value
	 *  and you want to take value like this $model->fieldname
	 *  @param $id
	 *  @return LaporanbbmdetailsModel
	 */
	public function show($request, $id)
	{
		$auth = json_decode($request->session()->get('auth'));

		$model = $this->model->getQuery()
			// ->where("laporanbbmdetails.id", "=", $id)->first();
			->where("laporanbbmdetails.reportId", "=", $id)->first();

		if ($model) {
			if ($model->tipe == "VOYAGE") { } else if ($model->tipe == "MONTH") { } else {
				$model = null;
			}
		}
		return $model;
	}

	public function showByMonth($report)
	{
		$model = (new LaporanbbmdetailsModel())->getQuery()
			->select([
				"laporanbbmdetails.*"
			])
			->where("laporanbbmdetails.tahun", "=", $report->tahun)
			->where("laporanbbmdetails.bulan", "=", $report->bulan)
			->orderBy("laporanbbmdetails.transactionDate", "ASC")
			->get();
		return $model;
	}

	public function showByVoyage($reportID)
	{
		$model = (new LaporanbbmdetailsModel())->getQuery()
			->select([
				"laporanbbmdetails.*"
			])
			->where("laporanbbmdetails.reportId", "=", $reportID)
			->orderBy("laporanbbmdetails.transactionDate", "ASC")
			->get();
		return $model;
	}

	/**
	 *  this is a base function for storing data you with transaction by default
	 *  you can customization base on your business requirement as you want, you can add other object or you can to loop anc excecute the process in single process
	 *  @param array $input
	 *  @return LaporanbbmdetailsModel
	 *  @throws \Exception
	 */
	public function store($input)
	{
		$jlhBarang = 0;
		if (isset($input["itemID"])) {
			$jlhBarang = array_sum($input["quantity"]);
		}
		$input["totalBarang"] = $jlhBarang;
		$input["locationId"] = 1;
		$input["type"] = 1;

		$transactionBrg = new LaporanbbmdetailsModel();
		$transactionBrg->fill($input);
		if (!$transactionBrg->save()) {
			throw new \Exception();
		}
		return $transactionBrg->id;
	}


	/**
	 * this function will delete much data, in one action
	 * the ids is a parameter from view like 1,2,3,4 and the parameter will be exploded into single array
	 * you can remove this main alogorithm with your business requirement like soft delete or anything you want
	 *  @param $ids
	 */
	public function delete($ids)
	{
		$params = explode(".", $ids);
		$this->model->deleteBulk("id", $params);
	}


	/**
	 *  this is a base function for update and delete data by default.
	 *  you can add and custom as you want base on your requirement you can add this function as core function for handle update data from table or 
	 *  you can add multiple relation proses after update in this function 
	 *  @param $id
	 *  @param array $input 
	 *  @return LaporanbbmdetailsModel
	 *  @throws \Exception
	 */
	public function update($id, $input)
	{
		$bbm = LaporanbbmdetailsModel::find($id);
		$bbm->fill($input);
		if (!$bbm->update()) {
			throw new \Exception();
		}
		return $bbm;
	}
}
